> ## Documentation Index
> Fetch the complete documentation index at: https://devdocs.xbox.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Upload Secret

> Uploads a multiplayer server game secret.

Allowed entity token types: title

## Error codes

This operation may return the following PlayFab errors:

| Error | Code |
| --- | --- |
| APINotEnabledForGameClientAccess | 1082 |
| MultiplayerServerBadRequest | 1382 |
| MultiplayerServerConflict | 1386 |
| MultiplayerServerForbidden | 1384 |
| MultiplayerServerInternalServerError | 1387 |
| MultiplayerServerNoContent | 1381 |
| MultiplayerServerNotFound | 1385 |
| MultiplayerServerTooManyRequests | 1380 |
| MultiplayerServerUnauthorized | 1383 |
| MultiplayerServerUnavailable | 1388 |
| ProductDisabledForTitle | 1609 |




## OpenAPI

````yaml /services/playfab/api-references/rest/multiplayer/multiplayer.openapi.json post /MultiplayerServer/UploadSecret
openapi: 3.0.0
info:
  version: '260922'
  title: PlayFab Multiplayer API
  description: >-
    API methods for managing multiplayer servers. API methods for managing
    parties. The lobby service helps players group together to play multiplayer
    games. It is often used as a rendezvous point for players to share
    connection information. The TrueSkill service helps titles to estimate a
    player's skill based on their match results. The player skill values from
    this service are commonly used by a matchmaking service to provide players
    with balanced matches.
  termsOfService: https://playfab.com/terms/
  contact:
    url: https://community.playfab.com/index.html
  license:
    name: Apache 2.0
    url: https://github.com/PlayFab/API_Specs/blob/master/LICENSE
servers:
  - url: https://{titleId}.playfabapi.com
    description: PlayFab title endpoint
    variables:
      titleId:
        default: your_title_id
        description: Your PlayFab title ID (hex).
security: []
tags:
  - name: Lobby
    description: ''
  - name: Matchmaking
    description: Matchmaking APIs
  - name: Matchmaking Admin
    description: Matchmaking Admin APIs
  - name: MultiplayerServer
    description: Multiplayer Server APIs
  - name: PubSub
    description: PlayFab PubSub APIs
  - name: TrueSkill
    description: TrueSkill APIs
  - name: TrueSkill Admin
    description: TrueSkill Admin APIs
paths:
  /MultiplayerServer/UploadSecret:
    post:
      tags:
        - MultiplayerServer
      summary: Upload Secret
      description: |
        Uploads a multiplayer server game secret.

        Allowed entity token types: title

        ## Error codes

        This operation may return the following PlayFab errors:

        | Error | Code |
        | --- | --- |
        | APINotEnabledForGameClientAccess | 1082 |
        | MultiplayerServerBadRequest | 1382 |
        | MultiplayerServerConflict | 1386 |
        | MultiplayerServerForbidden | 1384 |
        | MultiplayerServerInternalServerError | 1387 |
        | MultiplayerServerNoContent | 1381 |
        | MultiplayerServerNotFound | 1385 |
        | MultiplayerServerTooManyRequests | 1380 |
        | MultiplayerServerUnauthorized | 1383 |
        | MultiplayerServerUnavailable | 1388 |
        | ProductDisabledForTitle | 1609 |
      operationId: UploadSecret
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UploadSecretRequest'
        description: Uploads a multiplayer server game secret.
      responses:
        '200':
          $ref: '#/components/responses/EmptyResponse'
        '400':
          $ref: '#/components/responses/ApiErrorWrapper'
      security:
        - EntityToken: []
components:
  schemas:
    UploadSecretRequest:
      description: Uploads a multiplayer server game secret.
      type: object
      properties:
        CustomTags:
          description: >-
            The optional custom tags associated with the request (e.g. build
            number, external trace identifiers, etc.).
          type: object
        ForceUpdate:
          description: >-
            Forces the secret renewal if the secret already exists. Default is
            false
          type: boolean
        GameSecret:
          allOf:
            - $ref: '#/components/schemas/Secret'
          description: The game secret to add.
      required:
        - GameSecret
      example:
        GameSecret:
          Name: GameSecret1
          Value: Value123
          ExpirationDate: '2025-09-01T00:00:00'
        ForceUpdate: false
    Secret:
      type: object
      properties:
        ExpirationDate:
          description: Optional secret expiration date.
          type: string
        Name:
          description: >-
            A name for the secret. This is used to reference secrets in build
            configurations.
          type: string
        Value:
          description: Secret value.
          type: string
      required:
        - Name
        - Value
    EmptyResponse:
      type: object
      properties: {}
    ApiErrorWrapper:
      description: The basic wrapper around every failed API response
      type: object
      properties:
        code:
          description: Numerical HTTP code
          type: integer
        status:
          description: String HTTP code
          type: string
        error:
          description: Playfab error code
          type: string
        errorCode:
          description: Numerical PlayFab error code
          type: integer
        errorMessage:
          description: Description for the PlayFab errorCode
          type: string
        errorDetails:
          description: Detailed description of individual issues with the request object
          type: object
      required:
        - code
        - errorCode
  responses:
    EmptyResponse:
      description: ''
      content:
        application/json:
          schema:
            type: object
            properties:
              code:
                type: integer
                description: >-
                  The Http status code. If X-ReportErrorAsSuccess header is set
                  to true, this will report the actual http error code.
              status:
                type: string
                description: The Http status code as a string.
              data:
                $ref: '#/components/schemas/EmptyResponse'
    ApiErrorWrapper:
      description: This is the outer wrapper for all responses with errors
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiErrorWrapper'
  securitySchemes:
    EntityToken:
      type: apiKey
      in: header
      name: X-EntityToken
      description: >-
        This API requires an Entity Session Token, available from the Entity
        GetEntityToken method.

````

## Related topics

- [Upload Secret](/services/playfab/api-references/rest/multiplayer/multiplayer-server/upload-secret.md)
- [Manage secrets (Preview)](/services/playfab/multiplayer/servers/manage-secrets.md)
- [PlayFab Services SDK Release Notes 2024](/services/playfab/release-notes/2024.md)
- [PFMultiplayerServerSecretSummary](/services/playfab/api-references/c/pfmultiplayerservertypes/structs/pfmultiplayerserversecretsummary.md)
- [Make package (makepkg.exe)](/build/core-features/common/packaging/deployment/makepkg.md)
